#include <stdio.h>
#include <math.h>



int main() {

    int h,w,r,q,i=0,j=0,a,b;
    
    scanf("%d %d %d %d",&w,&h,&r,&q);
    w++;
    
    //printf("%d",w);
    float ref0[w];
    float h1[w];
    while(i<w){
      h1[i] = h;
      ref0[i]=h<r-sqrt(r*r-i*i)?h:r-sqrt(r*r-i*i);
      
      i++;
    }
    i=0;
    while(i<q){
      scanf("%d",&a);
      //printf("\na je %d,//i je %d,a q je %d",a,i,q);      
      if(a==1){
        scanf("%d %d",&a,&b);//printf("\n a je %d a b je %d",a,b);
        while(j<w){
          h1[j+a]= (h1[j+a]<b-r+ref0[j])?h1[j+a]:b-r+ref0[j];
          h1[a-j]= (h1[a-j]<b-r+ref0[j])?h1[a-j]:b-r+ref0[j];
          
          j++;
          
          if(a-j<0&&a+j>=w)
            j=w;
        }
        
      }
      else{
        scanf("%d",&a);
        printf("%.9f\n",h1[a]);
      }

      
      i++;
    }

    return 0;
}